DECLARE FUNCTION fontfilenumget% (fontnum%)
DECLARE FUNCTION boxmodeget% (boxnum%)
DECLARE FUNCTION valueget$ (w%)
DECLARE FUNCTION btstate% (w%)
DECLARE FUNCTION altpressed% ()
DECLARE FUNCTION arraycreate% (xsiz%, ysiz%, qua%)
DECLARE FUNCTION xmsdainit% (itemsmax%, sizebyt&)
DECLARE FUNCTION div% (V1%, V2%)
DECLARE FUNCTION filelength& (FileName$)
DECLARE FUNCTION bytes2int% (V1%, V2%)
DECLARE FUNCTION bounds% (v%, V1%, V2%)
DECLARE FUNCTION inbounds% (v%, V1%, V2%)
DECLARE FUNCTION boundss! (v!, V1!, V2!)
DECLARE FUNCTION col2int% (col&)
DECLARE FUNCTION wnditemnumb% (wndnum%, x%, y%)
DECLARE FUNCTION strlen% (a$, fontnum%)
DECLARE FUNCTION colfind& (R%, G%, B%)
DECLARE FUNCTION boxhelpget% (boxnum%)
DECLARE FUNCTION boxmsgget% (boxnum%)
DECLARE FUNCTION mousechange% ()
DECLARE FUNCTION pagecreate% (XRes%, YRes%, epn%)
DECLARE FUNCTION tagget% (boxnum%)
DECLARE FUNCTION tagsearch% (tag%)
DECLARE FUNCTION wnditemnum% (wndnum%, x%, y%)
DECLARE FUNCTION fullpathget$ ()
DECLARE FUNCTION curdriveget$ ()
DECLARE FUNCTION ctrlpressed% ()
DECLARE FUNCTION rshiftpressed% ()
DECLARE FUNCTION lshiftpressed% ()
DECLARE FUNCTION rgb2long& (R%, G%, B%)
DECLARE FUNCTION int2col& (v%)
DECLARE FUNCTION strget$ ()
DECLARE FUNCTION st$ (v%)
DECLARE FUNCTION xmsdanewaddr& (handle%, num%, sizebyt&)
DECLARE FUNCTION valueget$ (w%)
DECLARE FUNCTION btstate% (w%)

DEFINT A-Z

'$INCLUDE: 'common.bi'
'$INCLUDE: 'future.bi'
'$INCLUDE: 'xxxxxxxx.ppr'

DIM SHARED lastdx, lastdy

SUB boxgraphics (boxnum)
boxcoordsgetb boxnum, X1, Y1, X2, Y2
tag = tagget(boxnum)

SELECT CASE tag
END SELECT
END SUB

SUB btpress (w)
tag = tagget(w)
dtag = div(tag, 5)

SELECT CASE tag
END SELECT
END SUB

FUNCTION btstate (w)
tag = tagget(w)

s = -1
SELECT CASE tag
END SELECT
IF tag = s THEN P = 1
btstate = P + 2 * jammed + 8 * user
END FUNCTION

SUB keypress (I$)
IF LEN(I$) > 1 THEN
 I = -ASC(RIGHT$(I$, 1))
ELSE
 I = ASC(I$)
END IF
SELECT CASE I
END SELECT
END SUB

SUB moveover (w)
tag = tagget(w)
SELECT CASE tag
'MouseOn
'MouseOff
END SELECT
END SUB

SUB pageinit (n)
SELECT CASE n
END SELECT
END SUB

SUB programclose
END SUB

SUB programinit
sxres = scrxres
syres = scryres
gxsiz = xgrid
gysiz = ygrid
sbytes = coldepth
sqsiz = sqs
SetScreenMode sxres, syres, sbytes * 8
xp = INT((sxres - gxsiz * sqsiz) / 2)
yp = INT((syres - gysiz * sqsiz) / 2)

pagescreate
if bgfile$<>"" then bgload comdir$ + bgfile$
pageload comdir$ + pagefile$
skinload comdir$ + skinfile$
imgload comdir$ + imgfile$
msgload comdir$ + msgfile$, 1
wndload comdir$ + wndfile$
fontload comdir$ + fontsfile$

pageset 1
SetPage 0
END SUB

SUB resident

END SUB

SUB scrollbarget (w, vmin!, vmax!, ssize!, v!)
tag = tagget(w)
SELECT CASE tag
END SELECT
END SUB

SUB scrollbarset (w%, v!)
tag = tagget(w)
SELECT CASE tag
END SELECT
END SUB

FUNCTION valueget$ (w)
tag = tagget(w)

SELECT CASE tag
END SELECT

IF vi <> 0 THEN
 v$ = STR$(vi)
ELSEIF vs! <> 0 THEN
 v$ = STR$(vs!)
END IF
valueget$ = RTRIM$(LTRIM$(v$))
END FUNCTION

SUB valueset (w, v$)
tag = tagget(w)
dtag = div(tag, 5)

vi = 1 - (mb > 1) * 9
IF ctrlpressed THEN vi = vi * 100
IF dtag < tag THEN
 vg = 1
 vi = (1 + (tag = (dtag + 2)) * 2) * vi
 vs! = vi
ELSE
 vi = VAL(v$)
 vs! = VAL(v$)
END IF

SELECT CASE tag
END SELECT

END SUB

SUB wnddrag (w)
tag = tagget(w)
wndcoords w, 0, 0, 0, 0
dragget Mode, x, y
scrtowndb tag, x, y, X1, Y1
scrtowndb tag, mx, my, X2, Y2
dx = X2 - X1
dy = Y2 - Y1

SELECT CASE tag
END SELECT
END SUB

SUB wndinit (tag)
SELECT CASE tag
END SELECT
END SUB

SUB wnditemshow (w, num, X1, Y1, X2, Y2)
tag = tagget(w)
SELECT CASE tag
END SELECT
IF num = nn THEN dotbox X1, Y1, X2, Y2, 21845
END SUB

SUB wndprepare (w)

tag = tagget(w)
wndcoords w, X1, Y1, X2, Y2

col& = -1
SELECT CASE tag
END SELECT

IF col& >= 0 THEN Future.FILLBOX X1, Y1, X2, Y2, col&

END SUB

SUB wndpress (w)
IF w <= boxend THEN EXIT SUB
tag = tagget(w)
wndcoords w, 0, 0, 0, 0
v = wnditemnumb(tag, mx, my)
lastdx = 0
lastdy = 0

SELECT CASE tag
END SELECT
END SUB

