DECLARE SUB sqsxpypcalc ()
DECLARE SUB filesave (FileName$)
DECLARE SUB fileload (FileName$)
DECLARE SUB programlauch ()
DECLARE SUB btpress (w%)
DECLARE FUNCTION fontfilenumget% (fontnum%)
DECLARE FUNCTION boxmodeget% (boxnum%)
DECLARE FUNCTION valueget$ (w%)
DECLARE FUNCTION btstate% (w%)
DECLARE FUNCTION altpressed% ()
DECLARE FUNCTION arraycreate% (xsiz%, ysiz%, qua%)
DECLARE FUNCTION xmsdainit% (itemsmax%, sizebyt&)
DECLARE FUNCTION div% (V1%, V2%)
DECLARE FUNCTION filelength& (FileName$)
DECLARE FUNCTION bytes2int% (V1%, V2%)
DECLARE FUNCTION bounds% (v%, V1%, V2%)
DECLARE FUNCTION inbounds% (v%, V1%, V2%)
DECLARE FUNCTION boundss! (v!, V1!, V2!)
DECLARE FUNCTION col2int% (col&)
DECLARE FUNCTION wnditemnumb% (wndnum%, x%, y%)
DECLARE FUNCTION strlen% (a$, fontnum%)
DECLARE FUNCTION colfind& (R%, G%, B%)
DECLARE FUNCTION boxhelpget% (boxnum%)
DECLARE FUNCTION boxmsgget% (boxnum%)
DECLARE FUNCTION mousechange% ()
DECLARE FUNCTION pagecreate% (XRes%, YRes%, epn%)
DECLARE FUNCTION tagget% (boxnum%)
DECLARE FUNCTION tagsearch% (tag%)
DECLARE FUNCTION wnditemnum% (wndnum%, x%, y%)
DECLARE FUNCTION fullpathget$ ()
DECLARE FUNCTION curdriveget$ ()
DECLARE FUNCTION ctrlpressed% ()
DECLARE FUNCTION rshiftpressed% ()
DECLARE FUNCTION lshiftpressed% ()
DECLARE FUNCTION rgb2long& (R%, G%, B%)
DECLARE FUNCTION int2col& (v%)
DECLARE FUNCTION strget$ ()
DECLARE FUNCTION st$ (v%)
DECLARE FUNCTION xmsdanewaddr& (handle%, num%, sizebyt&)
DECLARE FUNCTION valueget$ (w%)
DECLARE FUNCTION btstate% (w%)

DEFINT A-Z

'$INCLUDE: 'common.bi'
'$INCLUDE: 'future.bi'
'$INCLUDE: 'xxxxxxxx.ppr'

CONST ext$ = ".USR"

DIM SHARED stres, stcol, sfilenum, sfilename$

SUB boxgraphics (boxnum)
boxcoordsgetb boxnum, x1, y1, x2, y2
tag = tagget(boxnum)

SELECT CASE tag
END SELECT
END SUB

SUB btpress (w)
tag = tagget(w)
dtag = div(tag, 5)

SELECT CASE tag
 CASE 950 TO 969
  a = stres
  stres = w
  boxupdateb a
 CASE 970 TO 972
  a = stcol
  stcol = w
  boxupdateb a
 CASE 976
  programlauch
 CASE 985, 986
  pathmaskget pth$, ""
  IF sfilename$ <> "" THEN
   f$ = pth$ + sfilename$ + ext$
   IF tag = 985 THEN fileload f$ ELSE filesave f$
  END IF
END SELECT
END SUB

FUNCTION btstate (w)
tag = tagget(w)

s = -1
SELECT CASE tag
 CASE 950 TO 969
  IF stres = w THEN P = 1
 CASE 970 TO 972
  IF stcol = w THEN P = 1
END SELECT
IF tag = s THEN P = 1
btstate = P + 2 * jammed + 8 * user
END FUNCTION

SUB fileload (FileName$)

END SUB

SUB filesave (FileName$)

END SUB

SUB keypress (i$)
IF LEN(i$) > 1 THEN
 i = -ASC(RIGHT$(i$, 1))
ELSE
 i = ASC(i$)
END IF
SELECT CASE i
END SELECT
END SUB

SUB moveover (w)
tag = tagget(w)
SELECT CASE tag
'MouseOn
'MouseOff
END SELECT
END SUB

SUB pageinit (n)
SELECT CASE n
END SELECT
END SUB

SUB programclose
OPEN "config.dat" FOR BINARY AS #1
 PUT #1, , stres
 PUT #1, , stcol
 pathmaskget thepath$, ""
 strput thepath$
CLOSE #1
END SUB

SUB programinit
gxsiz = xgrid
gysiz = INT(xgrid * .625)

sxres = 320: syres = 200: sbytes = 1
SetScreenMode sxres, syres, sbytes * 8
sqsxpypcalc
Future.CLS 255

pagescreate
skinload comdir$ + skinfile$
pageload comdir$ + pagefile$
imgload comdir$ + "small.pim"
msgload comdir$ + msgfile$, 1
fontload comdir$ + "small.pfn"
IF sbytes <> 2 THEN cursorset 10, 0

pageset 2

OPEN "config.dat" FOR BINARY AS #1
 GET #1, , stres
 GET #1, , stcol
 thepath$ = strget$
CLOSE #1
IF thepath$ = "" THEN thepath$ = fullpathget$
pathmaskset thepath$, ""

IF stres = 0 THEN stres = tagsearch(950)
btpress stres
IF stcol = 0 THEN stcol = tagsearch(970)
btpress stcol

END SUB

SUB programlauch
FreeAllExpMem

SetPage 0
Future.CLS 0

gysiz = ygrid
msgget boxmsgget(stres), m$
sxres = VAL(LEFT$(m$, 4))
syres = VAL(RIGHT$(m$, 4))
sbytes = 2 ^ (tagget(stcol) - 970)
SetScreenMode sxres, syres, sbytes * 8
sqsxpypcalc

IF sxres < 640 THEN
 ifacesize$ = "small"
ELSEIF sxres < 1024 THEN
 ifacesize$ = "medium"
ELSE
 ifacesize$ = "large"
END IF

pagescreate
if bgfile$<>"" then bgload comdir$ + bgfile$
pageload comdir$ + pagefile$
msgload comdir$ + msgfile$, 1
skinload comdir$ + skinfile$
imgload comdir$ + ifacesize$ + ".PIM"
wndload comdir$ + wndfile$
fontload comdir$ + ifacesize$ + ".PFN"
IF sbytes <> 2 THEN cursorset 10, 0

pathmaskset "C:\", ext$ + "."
dirget
wnditemset 1, -1, -1, filequa
pageset 1
SetPage 0

END SUB

SUB resident

END SUB

SUB scrollbarget (w, vmin!, vmax!, ssize!, v!)
tag = tagget(w)
SELECT CASE tag
END SELECT
END SUB

SUB scrollbarset (w%, v!)
tag = tagget(w)
SELECT CASE tag
END SELECT
END SUB

SUB sqsxpypcalc
sqsiz = INT(sxres / gxsiz)
sqsiz2 = INT(syres / gysiz)
IF sqsiz > sqsiz2 THEN sqsiz = sqsiz2
xp = INT((sxres - gxsiz * sqsiz) / 2)
yp = INT((syres - gysiz * sqsiz) / 2)
END SUB

FUNCTION valueget$ (w)
tag = tagget(w)

SELECT CASE tag
 CASE 980
  v$ = sfilename$
 CASE 981
  pathmaskget v$, ""
END SELECT

IF vi <> 0 THEN
 v$ = STR$(vi)
ELSEIF vs! <> 0 THEN
 v$ = STR$(vs!)
END IF
valueget$ = RTRIM$(LTRIM$(v$))
END FUNCTION

SUB valueset (w, v$)
tag = tagget(w)
dtag = div(tag, 5)

vi = 1 - (mb > 1) * 9
IF ctrlpressed THEN vi = vi * 100
IF dtag < tag THEN
 vg = 1
 vi = (1 + (tag = (dtag + 2)) * 2) * vi
 vs! = vi
ELSE
 vi = VAL(v$)
 vs! = VAL(v$)
END IF

SELECT CASE tag
 CASE 980
  sfilename$ = v$
 CASE 981
  pathmaskset v$, ""
  dirget
  wndrefreshtagb 1
END SELECT

END SUB

SUB wnddrag (w)
tag = tagget(w)
wndcoords w, 0, 0, 0, 0
dragget Mode, x, y
scrtowndb tag, x, y, x1, y1
scrtowndb tag, mx, my, x2, y2
dx = x2 - x1
dy = y2 - y1

SELECT CASE tag
END SELECT
END SUB

SUB wndinit (tag)
SELECT CASE tag
END SELECT
END SUB

SUB wnditemshow (w, num, x1, y1, x2, y2)
tag = tagget(w)
SELECT CASE tag
 CASE 1
  fileget num, FileName$, typ
  IF num = sfilenum THEN Future.FILLBOX x1, y1, x2, y2, colfind&(255, 255, 255)
  tprintwnd x1 + 4, y1, x2 - 4, y2, 0, 1, 1, FileName$
END SELECT
IF num = nn THEN dotbox x1, y1, x2, y2, -1
END SUB

SUB wndprepare (w)

tag = tagget(w)
wndcoords w, x1, y1, x2, y2

col& = -1
SELECT CASE tag
 CASE 1
  col& = colfind(192, 192, 192)
END SELECT

IF col& >= 0 THEN Future.FILLBOX x1, y1, x2, y2, col&

END SUB

SUB wndpress (w)
IF w <= boxend THEN EXIT SUB
tag = tagget(w)
wndcoords w, 0, 0, 0, 0
v = wnditemnumb(tag, mx, my)
lastdx = 0
lastdy = 0

SELECT CASE tag
 CASE 1
  sfilenum = v
  fileget v, FileName$, typ
  IF typ = 0 THEN
   sfilename$ = FileName$
   i = INSTR(sfilename$, ".")
   IF i THEN sfilename$ = LEFT$(sfilename$, i - 1)
   boxdrawtagb 980
  ELSE
   fileprocess sfilenum
   wnditemset 1, -1, -1, filequa
   boxdrawtagb 981
  END IF
  wndrefreshtagb 1
END SELECT
END SUB

