DECLARE SUB cursorset (imgn%, imgsn%)
DECLARE SUB dragset (active%, x%, Y%)
DECLARE SUB qhelp (filename$)
DECLARE SUB openforloading (filename$)
DECLARE SUB openforsaving (filename$)
DECLARE SUB outputset (n%)
DECLARE SUB screenviewportset ()
DECLARE SUB wndget (boxnum%)
DECLARE SUB wndviewportset (boxnum%, x1%, y1%, x2%, y2%)
DECLARE SUB dotline (x1%, y1%, x2%, y2%, bs%)
DECLARE SUB wndput (boxnum%)
DECLARE SUB bufput (boxnum%)
DECLARE SUB valueset (w%, v$)
DECLARE SUB scrtownd (tag%, Sx%, Sy%, wx!, wy!)
DECLARE SUB wndtoscr (tag%, wx!, wy!, Sx%, Sy%)
DECLARE SUB mouseon ()
DECLARE SUB mouseoff ()
DECLARE SUB boxgupdateb (fromtag%, totag%)
DECLARE SUB shellexit ()
DECLARE SUB boxcoordsgetb (boxnum%, x1%, y1%, x2%, y2%)
DECLARE SUB msgget (msgnum%, m$)
DECLARE SUB tprintwnd (x1%, y1%, x2%, y2%, halign%, valign%, fontnum%, a$)
DECLARE SUB boxupdateb (boxnum%)
DECLARE SUB dragget (active%, x%, Y%)
DECLARE SUB fontload (filename$)
DECLARE SUB imgload (filename$)
DECLARE SUB msgload (filename$, start%)
DECLARE SUB pageload (filename$)
DECLARE SUB pagescreate ()
DECLARE SUB pageset (pagenum%)
DECLARE SUB pathmaskget (pth$, msk$)
DECLARE SUB pathmaskset (pth$, msk$)
DECLARE SUB scrtowndb (tag%, Sx%, Sy%, wx%, wy%)
DECLARE SUB skinload (filename$)
DECLARE SUB wndcoords (boxnum%, x1%, y1%, x2%, y2%)
DECLARE SUB wnditemset (tag%, wid%, mode%, itemq%)
DECLARE SUB wndload (filename$)
DECLARE SUB wndrefreshtagb (tag%)
DECLARE SUB dotbox (x1%, y1%, x2%, y2%, Bitscan%)
DECLARE SUB boxdrawtagb (tag%)
DECLARE SUB dirget ()
DECLARE SUB fileget (num%, filename$, typ%)
DECLARE SUB fileprocess (filenum%)
DECLARE SUB strput (a$)
DECLARE SUB sqsxpypcalc ()
DECLARE SUB filesave (filename$)
DECLARE SUB fileload (filename$)
DECLARE SUB programlauch ()
DECLARE SUB btpress (w%)
DECLARE FUNCTION fontfilenumget% (fontnum%)
DECLARE FUNCTION boxmodeget% (boxnum%)
DECLARE FUNCTION valueget$ (w%)
DECLARE FUNCTION btstate% (w%)
DECLARE FUNCTION altpressed% ()
DECLARE FUNCTION arraycreate% (xsiz%, ysiz%, qua%)
DECLARE FUNCTION xmsdainit% (itemsmax%, sizebyt&)
DECLARE FUNCTION div% (V1%, V2%)
DECLARE FUNCTION filelength& (filename$)
DECLARE FUNCTION bytes2int% (V1%, V2%)
DECLARE FUNCTION bounds% (v%, V1%, V2%)
DECLARE FUNCTION inbounds% (v%, V1%, V2%)
DECLARE FUNCTION boundss! (v!, V1!, V2!)
DECLARE FUNCTION col2int% (col&)
DECLARE FUNCTION wnditemnumb% (wndnum%, x%, Y%)
DECLARE FUNCTION strlen% (a$, fontnum%)
DECLARE FUNCTION colfind& (R%, G%, B%)
DECLARE FUNCTION boxhelpget% (boxnum%)
DECLARE FUNCTION boxmsgget% (boxnum%)
DECLARE FUNCTION mousechange% ()
DECLARE FUNCTION pagecreate% (XRes%, YRes%, epn%)
DECLARE FUNCTION tagget% (boxnum%)
DECLARE FUNCTION tagsearch% (tag%)
DECLARE FUNCTION wnditemnum% (wndnum%, x%, Y%)
DECLARE FUNCTION fullpathget$ ()
DECLARE FUNCTION curdriveget$ ()
DECLARE FUNCTION ctrlpressed% ()
DECLARE FUNCTION rshiftpressed% ()
DECLARE FUNCTION lshiftpressed% ()
DECLARE FUNCTION rgb2long& (R%, G%, B%)
DECLARE FUNCTION int2col& (v%)
DECLARE FUNCTION strget$ ()
DECLARE FUNCTION st$ (v%)
DECLARE FUNCTION xmsdanewaddr& (handle%, num%, sizebyt&)
DECLARE FUNCTION valueget$ (w%)
DECLARE FUNCTION btstate% (w%)

DEFINT A-Z

'$INCLUDE: 'common.bi'
'$INCLUDE: 'future.bi'
'$INCLUDE: 'VGEDIT  .ppr'

CONST ext$ = ".USR"

DIM SHARED stres, stcol, sfilenum, sfilename$
DIM SHARED tool
DIM SHARED chained

TYPE vertex
 x AS SINGLE
 Y AS SINGLE
END TYPE

CONST vertmax = 100, figmax = 100

DIM SHARED vert(vertmax) AS vertex, figcol(figmax), figvert(figmax, 1 TO 3), figtype(figmax)
DIM SHARED vertq, figq
DIM SHARED selvert
DIM SHARED vertnum
DIM SHARED selcol

DEFINT A-Z

SUB boxgraphics (boxnum)
boxcoordsgetb boxnum, x1, y1, x2, y2
tag = tagget(boxnum)

SELECT CASE tag
END SELECT
END SUB

SUB btpress (w)
tag = tagget(w)
dtag = div(tag, 5)

SELECT CASE tag
 CASE 100 TO 104
  tool = tag - 100
  boxgupdateb 100, 104
 CASE 109
  chained = 1 - chained
 CASE 111 TO 112
  valueset w, ""
  boxdrawtagb 110
  wndrefreshtagb 3
 CASE 120
  pageset 3
 CASE 987
  pageset 1
 CASE 199
  IF mb = 3 THEN
   shellexit
  ELSE
   dragset 0, 0, 0
  END IF
 CASE 950 TO 969
  a = stres
  stres = w
  boxupdateb a
 CASE 970 TO 972
  a = stcol
  stcol = w
  boxupdateb a
 CASE 976
  programlauch
 CASE 985, 986
  pathmaskget pth$, ""
  IF sfilename$ <> "" THEN
   f$ = pth$ + sfilename$ + ext$
   IF tag = 985 THEN fileload f$ ELSE filesave f$
  END IF
END SELECT
END SUB

FUNCTION btstate (w)
tag = tagget(w)

s = -1
SELECT CASE tag
 CASE 100 TO 104
  s = tool + 100
 CASE 109
  P = chained
 CASE 950 TO 969
  IF stres = w THEN P = 1
 CASE 970 TO 972
  IF stcol = w THEN P = 1
END SELECT
IF tag = s THEN P = 1
btstate = P + 2 * jammed + 8 * user
END FUNCTION

SUB fileload (filename$)
openforloading filename$
 GET #1, , vertq
 GET #1, , figq
 FOR n = 1 TO vertq
  GET #1, , vert(n)
 NEXT n
 FOR n = 1 TO figq
  GET #1, , figtype(n)
  GET #1, , figcol(n)
  FOR k = 1 TO 3
   GET #1, , figvert(n, k)
  NEXT k
 NEXT n
CLOSE #1
END SUB

SUB filesave (filename$)
openforsaving filename$
 PUT #1, , vertq
 PUT #1, , figq
 FOR n = 1 TO vertq
  PUT #1, , vert(n)
 NEXT n
 FOR n = 1 TO figq
  PUT #1, , figtype(n)
  PUT #1, , figcol(n)
  FOR k = 1 TO 3
   PUT #1, , figvert(n, k)
  NEXT k
 NEXT n
CLOSE #1
END SUB

SUB keypress (i$)
IF LEN(i$) > 1 THEN
 i = -ASC(RIGHT$(i$, 1))
ELSE
 i = ASC(i$)
END IF
SELECT CASE i
 CASE -&H3B
  qhelp "DATA\f1help.txt"
END SELECT
END SUB

SUB moveover (w)
tag = tagget(w)
SELECT CASE tag
 CASE 2
  FOR n = 1 TO vertq
   wndtoscr 2, vert(n).x, vert(n).Y, x, Y
   IF ABS(x - mx) + ABS(Y - my) <= 3 THEN
    IF selvert <> n THEN
     selvert = n
     mouseoff
     wndrefreshtagb 2
     mouseon
    END IF
    EXIT SUB
   END IF
  NEXT n
  IF selvert > 0 THEN
   selvert = 0
   mouseoff
   wndrefreshtagb 2
   mouseon
  END IF
END SELECT
END SUB

SUB pageinit (n)
SELECT CASE n
END SELECT
END SUB

SUB programclose
OPEN "config.dat" FOR BINARY AS #1
 PUT #1, , stres
 PUT #1, , stcol
 pathmaskget thepath$, ""
 strput thepath$
CLOSE #1
END SUB

SUB programinit
gxsiz = xgrid
gysiz = INT(xgrid * .625)

sxres = 320: syres = 200: sbytes = 1
SetScreenMode sxres, syres, sbytes * 8
sqsxpypcalc
Future.CLS 255

pagescreate
skinload comdir$ + skinfile$
pageload comdir$ + pagefile$
imgload comdir$ + "small.pim"
msgload comdir$ + msgfile$, 1
fontload comdir$ + "small.pfn"
IF sbytes <> 2 THEN cursorset 10, 0

pageset 2

OPEN "config.dat" FOR BINARY AS #1
 GET #1, , stres
 GET #1, , stcol
 thepath$ = strget$
CLOSE #1
IF thepath$ = "" THEN thepath$ = fullpathget$
pathmaskset thepath$, ""

IF stres = 0 THEN stres = tagsearch(950)
btpress stres
IF stcol = 0 THEN stcol = tagsearch(970)
btpress stcol

vertnum = 1

END SUB

SUB programlauch
FreeAllExpMem

SetPage 0
Future.CLS 0

gysiz = ygrid
msgget boxmsgget(stres), m$
sxres = VAL(LEFT$(m$, 4))
syres = VAL(RIGHT$(m$, 4))
sbytes = 2 ^ (tagget(stcol) - 970)
SetScreenMode sxres, syres, sbytes * 8
sqsxpypcalc

IF sxres < 640 THEN
 ifacesize$ = "small"
ELSEIF sxres < 1024 THEN
 ifacesize$ = "medium"
ELSE
 ifacesize$ = "large"
END IF

pagescreate
IF syres / sxres >= .75 THEN
 pageload comdir$ + pagefile$
ELSE
 pageload "DATA\VGEDIT2.ppg"
 gysiz = 40
 sqsxpypcalc
END IF
msgload comdir$ + msgfile$, 1
skinload comdir$ + skinfile$
imgload comdir$ + ifacesize$ + ".PIM"
wndload comdir$ + wndfile$
fontload comdir$ + ifacesize$ + ".PFN"

pathmaskset "C:\", ext$ + "."
dirget
wnditemset 1, -1, -1, filequa
IF sbytes <> 2 THEN cursorset 10, 0
pageset 1
SetPage 0

END SUB

SUB resident

END SUB

SUB scrollbarget (w, vmin!, vmax!, ssize!, v!)
tag = tagget(w)
SELECT CASE tag
END SELECT
END SUB

SUB scrollbarset (w%, v!)
tag = tagget(w)
SELECT CASE tag
END SELECT
END SUB

SUB sqsxpypcalc
sqsiz = INT(sxres / gxsiz)
sqsiz2 = INT(syres / gysiz)
IF sqsiz > sqsiz2 THEN sqsiz = sqsiz2
xp = INT((sxres - gxsiz * sqsiz) / 2)
yp = INT((syres - gysiz * sqsiz) / 2)
END SUB

FUNCTION valueget$ (w)
tag = tagget(w)

SELECT CASE tag
 CASE 110
  vi = selcol
 CASE 980
  v$ = sfilename$
 CASE 981
  pathmaskget v$, ""
END SELECT

IF vi <> 0 THEN
 v$ = STR$(vi)
ELSEIF vs! <> 0 THEN
 v$ = STR$(vs!)
END IF
valueget$ = RTRIM$(LTRIM$(v$))
END FUNCTION

SUB valueset (w, v$)
tag = tagget(w)
dtag = div(tag, 5)

vi = 1 - (mb > 1) * 9
IF ctrlpressed THEN vi = vi * 100
IF dtag < tag THEN
 vg = 1
 vi = (1 + (tag = (dtag + 2)) * 2) * vi
 vs! = vi
ELSE
 vi = VAL(v$)
 vs! = VAL(v$)
END IF

SELECT CASE tag
 CASE 110 TO 112
  selcol = bounds(selcol * vg + vi, 0, 255)
  wndrefreshtagb 3
 CASE 980
  sfilename$ = v$
 CASE 981
  pathmaskset v$, ""
  dirget
  wndrefreshtagb 1
END SELECT

END SUB

SUB wnddrag (w)
tag = tagget(w)
wndcoords w, 0, 0, 0, 0
dragget mode, x, Y
scrtowndb tag, x, Y, x1, y1
scrtowndb tag, mx, my, x2, y2
dx = x2 - x1
dy = y2 - y1

SELECT CASE tag
 CASE 2
  IF selvert > 0 AND tool = 0 AND mb = 1 THEN
   IF mode = 1 THEN
   ' Mode 1 means "during drag'
    wndput w
    wndviewportset w, 0, 0, 0, 0
    outputset 0
    dotline x, Y, mx, my, 21845
    scrtownd 2, mx, my, vert(selvert).x, vert(selvert).Y
    bufput 0
    screenviewportset
   ELSE
   ' Mode 2 means "after drag'
    wndrefreshtagb 2
   END IF
  END IF
END SELECT
END SUB

SUB wndinit (tag)
SELECT CASE tag
END SELECT
END SUB

SUB wnditemshow (w, num, x1, y1, x2, y2)
tag = tagget(w)
SELECT CASE tag
 CASE 1
  fileget num, filename$, typ
  IF num = sfilenum THEN Future.FILLBOX x1, y1, x2, y2, colfind&(255, 255, 255)
  tprintwnd x1 + 4, y1, x2 - 4, y2, 0, 1, 1, filename$
 CASE 2
  FOR n = 1 TO figq
   v = figvert(n, 1)
   wndtoscr 2, vert(v).x, vert(v).Y, x1, y1
   v = figvert(n, 2)
   wndtoscr 2, vert(v).x, vert(v).Y, x2, y2
   col = figcol(n)
   SELECT CASE figtype(n)
    CASE 1
     future.line x1, y1, x2, y2, col, -1
    CASE 2
     v = figvert(n, 3)
   wndtoscr 2, vert(v).x, vert(v).Y, x3, y3
     future.trifill x1, y1, x2, y2, x3, y3, col
    CASE 3
     Future.FILLBOX x1, y1, x2, y2, col
    CASE 4
     future.fillcircle x1, y1, SQR(0& + 1& * (x2 - x1) * (x2 - x1) + 1& * (y2 - y1) * (y2 - y1)), col
   END SELECT
  NEXT n
  FOR n = 1 TO vertq
   wndtoscr 2, vert(n).x, vert(n).Y, Sx, Sy
   IF n = selvert THEN col = 13 ELSE col = 15
   FOR k = 1 TO vertnum - 1
    IF figvert(figq + 1, k) = n THEN col = 64
   NEXT k
   future.circle Sx, Sy, 2, col
   future.line Sx - 4, Sy, Sx + 4, Sy, col, -1
   future.line Sx, Sy - 4, Sx, Sy + 4, col, -1
  NEXT n
  wndget w
 CASE 3
  Future.FILLBOX x1, y1, x2, y2, num - 1
  nn = selcol + 1
END SELECT
IF num = nn THEN dotbox x1, y1, x2, y2, -1
END SUB

SUB wndprepare (w)

tag = tagget(w)
wndcoords w, x1, y1, x2, y2

col& = -1
SELECT CASE tag
 CASE 1
  col& = colfind(192, 192, 192)
 CASE 2
  col& = colfind(0, 0, 0)
 CASE 3
  col& = colfind(0, 0, 0)
END SELECT

IF col& >= 0 THEN Future.FILLBOX x1, y1, x2, y2, col&

END SUB

SUB wndpress (w)
IF w <= boxend THEN EXIT SUB
tag = tagget(w)
wndcoords w, 0, 0, 0, 0
v = wnditemnumb(tag, mx, my)
lastdx = 0
lastdy = 0

SELECT CASE tag
 CASE 1
  sfilenum = v
  fileget v, filename$, typ
  IF typ = 0 THEN
   sfilename$ = filename$
   i = INSTR(sfilename$, ".")
   IF i THEN sfilename$ = LEFT$(sfilename$, i - 1)
   boxdrawtagb 980
  ELSE
   fileprocess sfilenum
   wnditemset 1, -1, -1, filequa
   boxdrawtagb 981
  END IF
  wndrefreshtagb 1
 CASE 2
  IF mb = 2 THEN
   ' If user pressed right mouse button then ..
   IF tool = 0 AND selvert > 0 THEN
    vert(selvert) = vert(vertq)
    n = 1
    DO
     FOR nn = 1 TO 2 - (figtype(n) = 2)
      IF figvert(n, nn) = selvert THEN
       figcol(n) = figcol(figq)
       figvert(n, 1) = figvert(figq, 1)
       figvert(n, 2) = figvert(figq, 2)
       figvert(n, 3) = figvert(figq, 3)
       figtype(n) = figtype(figq)
       figq = figq - 1
       n = n - 1
       EXIT FOR
      END IF
      IF figvert(n, nn) = vertq THEN figvert(n, nn) = selvert
     NEXT nn
     n = n + 1
     IF n > figq THEN EXIT DO
    LOOP
    vertq = vertq - 1
    selvert = 0
    ' If user is working with vertex tool then this block deletes selected vertex by moving last vertex
    ' to its position. The loop is for correcting errors (following this moving) in figure vertexes array.
   ELSE
    vertnum = 1
    ' Otherwise, vertex selection for figure will be resetted
   END IF
  ELSE
   IF selvert = 0 THEN
    vertq = vertq + 1
    scrtownd 2, mx, my, vert(vertq).x, vert(vertq).Y
    selvert = vertq
   END IF
   ' This block adds vertex if no one is selected

   IF tool = 0 THEN EXIT SUB
   ' Tool 0 just creates vertexes

   FOR n = 1 TO vertnum - 1
    IF figvert(figq + 1, n) = selvert THEN EXIT SUB
   NEXT n
   ' Checking if this vertex is already selected for this figure

   figvert(figq + 1, vertnum) = selvert
   ' Including this vertex to the figure's vertexes

   IF tool = 2 THEN maxvert = 3 ELSE maxvert = 2
   ' Triangle tool requires 3 vertexes, others - 2

   IF vertnum = maxvert THEN
    figq = figq + 1
    figcol(figq) = selcol
    IF chained THEN
     IF tool = 2 THEN
      figvert(figq + 1, 1) = figvert(figq, 1)
      figvert(figq + 1, 2) = figvert(figq, 3)
     ELSE
      figvert(figq + 1, 1) = figvert(figq, 2)
     END IF
    ELSE
     vertnum = 1
    END IF
    figtype(figq) = tool
    ' "Chained" option includes previously selected vertexes in next figure.
   ELSE
    vertnum = vertnum + 1
   END IF
   ' If this vertex is last, finish the figure, else user selects next
  END IF
  wndrefreshtagb 2
 CASE 3
  selcol = v - 1
  wndrefreshtagb 3
  boxdrawtagb 110
END SELECT
END SUB

